/' Copyright (c) 2007 Scott Lembcke
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 '/

'' TODO: Comment me!
	
extern cp_constraint_bias_coef alias "cp_constraint_bias_coef" as cpFloat

type cpConstraintClassPTR as cpConstraintClass ptr
type cpConstraintPTR as cpConstraint ptr

type cpConstraintPreStepFunction as sub cdecl( byval as cpConstraintPTR, byval as cpFloat, byval as cpFloat )
type cpConstraintApplyImpulseFunction as sub cdecl( byval as cpConstraintPTR )
type cpConstraintGetImpulseFunction as function cdecl( byval as cpConstraintPTR ) as cpFloat

type cpConstraintClass
	as cpConstraintPreStepFunction		preStep
	as cpConstraintApplyImpulseFunction	applyImpulse
	as cpConstraintGetImpulseFunction	getImpulse
end type

type cpConstraint
	as cpConstraintClass ptr	klass
	
	as cpBody ptr				a, b
	as cpFloat					maxForce
	as cpFloat					biasCoef
	as cpFloat					maxBias
	
	as cpDataPointer			data
end type

#ifdef CP_USE_DEPRECATED_API_4
type cpJoint as cpContraint
#endif

declare sub cpConstraintDestroy cdecl alias "cpConstraintDestroy" ( byval as cpConstraint ptr )
declare sub cpConstraintFree cdecl alias "cpConstraintFree" ( byval as cpConstraint ptr )

private sub cpConstraintActivateBodies( byval constraint as cpConstraint ptr )
	var a = constraint->a : if a then cpBodyActivate(a)
	var b = constraint->b : if b then cpBodyActivate(b)
end sub

#macro cpConstraintCheckCast(constraint, struct) 
	cpAssert(constraint->klass = struct##GetClass(), "Constraint is not a " #struct )
#endmacro


#define CP_DefineConstraintGetter( t, rt, m, n)	private function t##Get##n ( byval constraint as const cpConstraint ptr ) as rt : cpConstraintCheckCast( constraint, t ) : return cptr( t ptr, constraint )->m : end function
#define CP_DefineConstraintSetter( t, rt, m, n)	private sub t##Set##n ( byval constraint as cpConstraint ptr, byval value as rt ) : cpConstraintCheckCast( constraint, t ) : cptr( t ptr, constraint )->m = value : end sub

#macro CP_DefineConstraintProperty(s, t, m, n)
CP_DefineConstraintGetter(s, t, m, n)
CP_DefineConstraintSetter(s, t, m, n)
#endmacro

'' Built in Joint types
#include "cpPinJoint.bi"
#include "cpSlideJoint.bi"
#include "cpPivotJoint.bi"
#include "cpGrooveJoint.bi"
#include "cpDampedSpring.bi"
#include "cpDampedRotarySpring.bi"
#include "cpRotaryLimitJoint.bi"
#include "cpRatchetJoint.bi"
#include "cpGearJoint.bi"
#include "cpSimpleMotor.bi"

